/*
Part of the algoviz@vt collection of algorithm visualizations.
Copyright (C) 2007  Virginia Tech Department of Computer Science

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
import java.io.*;

public class FiFoAlgorithm 
{
  int[] diskSpace;
  int[] MainMemory;
  
    
  public FiFoAlgorithm ( int[] a, int[] b )
  {
  	diskSpace = a;
  	MainMemory = b;
  }
  
  public void InsertElement ( int AnElement, int MainMemoryP )
  {
    if ( MainMemoryP == 5 )
    {
      diskSpace[MainMemory[4]] = -1;
      
      for ( int i=4; i > 0; i-- )
      {
        MainMemory[i] = MainMemory[i-1];
      }
      
      MainMemory[0] = AnElement;
      diskSpace[AnElement] = 1;
    }
    else
    {
      
      for ( int i=MainMemoryP ; i >0; i-- )
      {
      	MainMemory [i] = MainMemory[i-1];
      }
      MainMemory [0] = AnElement;
    }
  }
  
  public boolean DeletePage ( int MainMemoryP, int AnElement )
  {
  	boolean Delete;
  	
  	if ( MainMemoryP > 0 )
  	{
  	  return false;
    }
    
    else
    {
      for ( int i=0; i < 5; i++ )
      {
      	if ( MainMemory [i] == AnElement )
      	  return false;
      }
      
      return true;
    }
  
  }	
  	
}
  	
  	
    