/*
Part of the algoviz@vt collection of algorithm visualizations.
Copyright (C) 2007  Virginia Tech Department of Computer Science

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
import java.io.*;

public class LruAlgorithm
{
  int[] diskSpace;
  int[] MainMemory;
  boolean IsElement;
  int PageRemoved;
  int index=0;
    
  public LruAlgorithm ( int[] a, int[] b )
  {
  	diskSpace = a;
  	MainMemory = b;
  	IsElement = false;
  }

  public void InsertElement ( int AnElement, int MainMemoryP )
  {
    for ( int i=0; i<5;i++ )
    {
      if ( MainMemory [i] == AnElement )
      {
        IsElement = true;
        index = i;
      }
    }

  	if ( MainMemoryP < 5 )
    {
      if ( !IsElement )
      {
        diskSpace[AnElement] = 1;
        
        for ( int i=MainMemoryP; i>0; i-- )
        {
          MainMemory[i] = MainMemory[i-1];
        }
        
        MainMemory [0] = AnElement;
        
      }
      else
      {
      	for ( int i=index; i>0;i--)
      	{
      	  MainMemory[i] = MainMemory[i-1];      	 
        }
         MainMemory[0] = AnElement;
      }
    }
    else 
    {
      if ( IsElement == true )
      {
        for ( int i = index; i>0; i--)
          MainMemory [i] = MainMemory[i-1];
      
        MainMemory[0] = AnElement;
      }
    
      else
      {
        diskSpace[MainMemory[4]] = -1;
        PageRemoved = MainMemory [4];
        for ( int i=4; i >0; i-- )
        {
          MainMemory[i] = MainMemory[i-1];
        }
        MainMemory[0] = AnElement;
        diskSpace[AnElement] = 1;
      }
    }
  }
  
  public boolean IsElementThere ( int AnElement, int Pointer )
  {
  	
  	for ( int i=0; i < Pointer; i++ )
  	{
  	  if ( MainMemory[i] == AnElement )
  	  {
  	  	return true;
  	  }
  	}
  	
  	return false;
  }
  
  public void SetIsElement ( boolean value )
  {
  	IsElement = value;
  }
  
  public int Pageremoved ( )
  {
  	return PageRemoved;
  }
  
  public int Index ( int AnElement, int Pointer)
  {
  	int position =0;

  	for ( int i=0; i < Pointer; i++ )
  	{
  	  if ( AnElement == MainMemory[i] )
  	     position = i;
    }

    return position;
  }
}
  	
  	
